﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{

    public partial class Commo : Form
    {
        
        public delegate void AddTxRxText(char[] d, int n);
        public AddTxRxText trxDelegate;

        public Commo()
        {
            InitializeComponent();
            trxDelegate = new AddTxRxText(AddTxRxTextMethod);
            string[] ports = System.IO.Ports.SerialPort.GetPortNames();
            if (ports.Length > 0)
                foreach (string S in ports)
                    comboBoxCOMPort.Items.Add(S);
            else
                comboBoxCOMPort.Items.Add("No Serial Ports");
            comboBoxCOMPort.SelectedIndex = 0;
            comboBoxBaudRate.SelectedIndex = 2;
            comboBoxSettings.SelectedIndex = 0;
        }
    
        public void AddTxRxTextMethod(char[] d, int n)
        {
            string S = new string(d, 0, n);
            textBoxDisplayRich.SelectionColor = System.Drawing.Color.FromName("Green");
            textBoxDisplayRich.AppendText(S);
            textBoxDisplayRich.SelectionColor = System.Drawing.Color.FromName("Black");
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            System.IO.Ports.SerialPort P = sender as System.IO.Ports.SerialPort;
            int n = P.BytesToRead;
            char[] d = new char[n];
            P.Read(d, 0, n);
            BeginInvoke(trxDelegate, new Object[]{d, n}); 
        }

        private void buttonConnect_Click(object sender, EventArgs e)
        {
            if (!serialPort1.IsOpen)
            {
                switch (comboBoxSettings.SelectedIndex) 
                {
                    case 0: // 7E1
                        serialPort1 = new System.IO.Ports.SerialPort(comboBoxCOMPort.Text, Convert.ToInt32(comboBoxBaudRate.Text), System.IO.Ports.Parity.Even, 7, System.IO.Ports.StopBits.One);
                        break;
                    case 1: // 8N1
                        serialPort1 = new System.IO.Ports.SerialPort(comboBoxCOMPort.Text, Convert.ToInt32(comboBoxBaudRate.Text), System.IO.Ports.Parity.None, 8, System.IO.Ports.StopBits.One);
                        break;
                }
                serialPort1.Handshake = System.IO.Ports.Handshake.None;
                serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);
                serialPort1.ReadTimeout = 500;
                serialPort1.WriteTimeout = 500;
                serialPort1.NewLine = "\r\n";
                serialPort1.Open();
                buttonConnect.Text = "Disconnect";

                textBoxTXData.Enabled = true;
            }else{
                buttonConnect.Text = "Connect";
                serialPort1.Close();
                textBoxTXData.Enabled = false;
            }
        }

        private void textBoxTXData_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Return) 
            {
                serialPort1.WriteLine(textBoxTXData.Text);
                textBoxDisplayRich.SelectionColor = System.Drawing.Color.FromName("Blue");
                textBoxDisplayRich.AppendText(textBoxTXData.Text + '\r' + '\n');
                textBoxDisplayRich.SelectionColor = System.Drawing.Color.FromName("Black");
                textBoxTXData.SelectAll(); 
                e.Handled = true;
            }
        }
    }
}
